#include <iostream>
#include <string>
#include <map>
#include <set>

#define SCRIPT_MODE

const unsigned offset(0x1d40), cluster_sz(32);
const char* img = "/home/chad/usr_chad/joshrec/drive.img";

using namespace std;

typedef map<string, unsigned> dir;

// Forest of dirs.
set<unsigned> s;
map<unsigned, dir*> f;
map<unsigned, unsigned> sz;

void pound(unsigned d, unsigned sub, string name) {
  // cout << "# " << d << ' ' <<  name << endl;
  s.insert(d);
  
  if (!f[d]) f[d] = new dir();
  f[d]->insert(make_pair((string)name, (unsigned)sub));
}

void at(unsigned d, unsigned loc, unsigned size, string name) {
  // cout << "@ " << d << ' ' << name << endl;
  s.insert(d);
  if (!f[d]) f[d] = new dir();
  f[d]->insert(make_pair((string)name, (unsigned)loc));
  f[loc] = NULL;
  sz[loc] = size;
}

void prune(dir *p) {
  if (!p) return;

  for (auto x : *p) {
    prune(f[x.second]);
    s.erase(x.second);
  }
}

void prune() {
  for (auto &x : f)
    prune(x.second);
}

void print_hier(dir *p, int indent = 1) {
  for (auto &x : *p) {
    #ifdef SCRIPT_MODE
    #else
    for (unsigned i = 0; i < indent; ++i) cout << "    ";
    cout << x.first << endl;
    #endif

    if (f[x.second]) {
      #ifdef SCRIPT_MODE
      cout << "mkdir " << x.first << endl
           << "cd " << x.first << endl;
      #endif
      print_hier(f[x.second], indent + 1);
      #ifdef SCRIPT_MODE
      cout << "cd .." << endl;
      #endif
    }
    #ifdef SCRIPT_MODE
    else {
      cout << "# PULL A " << sz[x.second] << " BYTE FILE CALLED " << x.first
           << " FROM " << x.second << endl;
      cout << "dd if=\"" << img << "\" of=" << x.first
           << " bs=512 count=" << (sz[x.second]+511)/512
           << " skip=" << offset + x.second*cluster_sz << endl;
    }
    #endif
  }
}

void print_hier() {
  for (auto x : s) {
    if (f[x]) {
      #ifdef SCRIPT_MODE
      cout << "mkdir " << x << endl
           << "cd " << x << endl;
      #else
      cout << x << endl;
      #endif

      print_hier(f[x]);

      #ifdef SCRIPT_MODE
      cout << "cd .." << endl;
      #endif
    } else {
      cout << "# ROOT FILE AT " << x << endl;
    }
  }
}

int main() {
  // Read directory info.
  char c, buf[512];
  while (!!cin) {
    cin >> c;
    if (c == '#') {
      string name;
      unsigned here, sub;
      cin >> here >> sub;
      cin.get();
      cin.getline(buf, 512);
      name = buf;
      pound(here, sub, name);
    } else if (c == '@') {
      string name;
      unsigned here, loc, size;
      cin >> here >> loc >> size;
      cin.get();
      cin.getline(buf, 512);
      name = buf;
      at(here, loc, size, name);
    } else {
      cout << "c is " << c << endl;
    }
  }

  // Print directory hierarchy.
  prune();
  print_hier();
  
  return 0;
}
